Index: trunk/SophyaLib/NTools/Makefile
===================================================================
--- trunk/SophyaLib/NTools/Makefile	(revision 230)
+++ trunk/SophyaLib/NTools/Makefile	(revision 231)
@@ -11,205 +11,220 @@
 endif 
  
-$(OBJ)cimage.o: cimage.cc /home/ansari/DPC/Include/defs.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h cimage.h rzimage.h rzvect.h \
- /home/ansari/DPC/Include/machine.h datatypes.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h dvlist.h fct1dfit.h generalfit.h \
- matrix.h peida.h utils.h fmath.h cvector.h generaldata.h poly.h \
- histos.h nbconst.h
-$(OBJ)cspline.o: cspline.cc /home/ansari/DPC/Include/defs.h nbtri.h \
+$(OBJ)cimage.o: cimage.cc $(INC)defs.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h cimage.h rzimage.h rzvect.h \
+ $(INC)machine.h datatypes.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h dvlist.h fct1dfit.h \
+ generalfit.h matrix.h peida.h utils.h fmath.h cvector.h generaldata.h \
+ poly.h histos.h nbconst.h
+$(OBJ)cspline.o: cspline.cc $(INC)defs.h nbtri.h \
  cspline.h cvector.h matrix.h peida.h utils.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h fmath.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h
-$(OBJ)cvector.o: cvector.cc /home/ansari/DPC/Include/defs.h cvector.h \
- matrix.h peida.h utils.h /home/ansari/DPC/Include/machine.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h fmath.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h generalfit.h generaldata.h \
- poly.h
-$(OBJ)datacards.o: datacards.cc /home/ansari/DPC/Include/defs.h datacards.h \
- peida.h utils.h /home/ansari/DPC/Include/machine.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h fmath.h
-$(OBJ)datatypes.o: datatypes.cc /home/ansari/DPC/Include/defs.h datatypes.h \
- /home/ansari/DPC/Include/machine.h
-$(OBJ)dates.o: dates.cc /home/ansari/DPC/Include/defs.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h dates.h
-$(OBJ)difeq.o: difeq.cc /home/ansari/DPC/Include/defs.h difeq.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h cvector.h matrix.h peida.h \
- utils.h /home/ansari/DPC/Include/machine.h \
- /home/ansari/DPC/Include/perrors.h fmath.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h \
- /home/ansari/DPC/Include/ctimer.h /home/ansari/DPC/Include/peida.h
-$(OBJ)dvlist.o: dvlist.cc /home/ansari/DPC/Include/defs.h dvlist.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/machine.h /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h \
- /home/ansari/DPC/Include/pclassids.h strutil.h
-$(OBJ)dynccd.o: dynccd.cc /home/ansari/DPC/Include/defs.h fmath.h perandom.h \
- /home/ansari/DPC/Include/machine.h histos.h peida.h utils.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h cvector.h matrix.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h nbrandom.h cimage.h rzimage.h \
- rzvect.h datatypes.h dvlist.h dynccd.h
-$(OBJ)fct1dfit.o: fct1dfit.cc /home/ansari/DPC/Include/defs.h fct1dfit.h \
- generalfit.h /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h matrix.h peida.h utils.h \
- /home/ansari/DPC/Include/machine.h /home/ansari/DPC/Include/perrors.h \
- fmath.h /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h cvector.h generaldata.h poly.h \
- nbconst.h tabmath.h
-$(OBJ)fct2dfit.o: fct2dfit.cc /home/ansari/DPC/Include/defs.h fct2dfit.h \
- generalfit.h /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h matrix.h peida.h utils.h \
- /home/ansari/DPC/Include/machine.h /home/ansari/DPC/Include/perrors.h \
- fmath.h /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h cvector.h generaldata.h poly.h \
- nbconst.h tabmath.h simps2d.h
-$(OBJ)generaldata.o: generaldata.cc /home/ansari/DPC/Include/defs.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h nbtri.h generalfit.h matrix.h \
- peida.h utils.h fmath.h /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h cvector.h generaldata.h poly.h
-$(OBJ)generalfit.o: generalfit.cc /home/ansari/DPC/Include/defs.h \
- generalfit.h /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h matrix.h peida.h utils.h \
- /home/ansari/DPC/Include/machine.h /home/ansari/DPC/Include/perrors.h \
- fmath.h /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h cvector.h generaldata.h poly.h \
- nbconst.h tabmath.h
-$(OBJ)hisprof.o: hisprof.cc /home/ansari/DPC/Include/defs.h hisprof.h \
- peida.h utils.h /home/ansari/DPC/Include/machine.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h fmath.h cvector.h matrix.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h histos.h
-$(OBJ)histos.o: histos.cc /home/ansari/DPC/Include/defs.h histos.h peida.h \
- utils.h /home/ansari/DPC/Include/machine.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h fmath.h cvector.h matrix.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h poly.h strutil.h generalfit.h \
- generaldata.h
-$(OBJ)histos2.o: histos2.cc /home/ansari/DPC/Include/defs.h histos2.h \
- peida.h utils.h /home/ansari/DPC/Include/machine.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h fmath.h histos.h cvector.h \
- matrix.h /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h generalfit.h generaldata.h \
- poly.h
-$(OBJ)imageop.o: imageop.cc /home/ansari/DPC/Include/defs.h simplesort.h \
- peida.h utils.h /home/ansari/DPC/Include/machine.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h fmath.h nbmath.h histos.h \
- cvector.h matrix.h /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h datatypes.h imageop.h cimage.h \
- rzimage.h rzvect.h dvlist.h cspline.h nbtri.h
-$(OBJ)integ.o: integ.cc /home/ansari/DPC/Include/defs.h integ.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h generalfit.h matrix.h peida.h \
- utils.h /home/ansari/DPC/Include/machine.h \
- /home/ansari/DPC/Include/perrors.h fmath.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h cvector.h generaldata.h poly.h
-$(OBJ)linfit.o: linfit.cc /home/ansari/DPC/Include/defs.h peida.h utils.h \
- /home/ansari/DPC/Include/machine.h /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h fmath.h linfit.h matrix.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h cvector.h
-$(OBJ)matrix.o: matrix.cc /home/ansari/DPC/Include/defs.h peida.h utils.h \
- /home/ansari/DPC/Include/machine.h /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h fmath.h matrix.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h cvector.h generalfit.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h
+$(OBJ)cvector.o: cvector.cc $(INC)defs.h cvector.h \
+ matrix.h peida.h utils.h $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h generalfit.h generaldata.h \
+ poly.h
+$(OBJ)datacards.o: datacards.cc $(INC)defs.h \
+ datacards.h peida.h utils.h $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h fmath.h
+$(OBJ)datatypes.o: datatypes.cc $(INC)defs.h \
+ datatypes.h $(INC)machine.h
+$(OBJ)dates.o: dates.cc $(INC)defs.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h dates.h
+$(OBJ)difeq.o: difeq.cc $(INC)defs.h difeq.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h cvector.h matrix.h peida.h \
+ utils.h $(INC)machine.h \
+ $(INC)perrors.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h \
+ $(INC)ctimer.h \
+ $(INC)peida.h
+$(OBJ)dvlist.o: dvlist.cc $(INC)defs.h dvlist.h \
+ $(INC)ppersist.h \
+ $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h \
+ $(INC)pclassids.h strutil.h
+$(OBJ)dynccd.o: dynccd.cc $(INC)defs.h fmath.h \
+ perandom.h $(INC)machine.h histos.h peida.h \
+ utils.h $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h cvector.h matrix.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h nbrandom.h cimage.h \
+ rzimage.h rzvect.h datatypes.h dvlist.h dynccd.h
+$(OBJ)fct1dfit.o: fct1dfit.cc $(INC)defs.h fct1dfit.h \
+ generalfit.h $(INC)exceptions.h \
+ $(INC)peidainit.h matrix.h peida.h utils.h \
+ $(INC)machine.h \
+ $(INC)perrors.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h cvector.h generaldata.h \
+ poly.h nbconst.h tabmath.h
+$(OBJ)fct2dfit.o: fct2dfit.cc $(INC)defs.h fct2dfit.h \
+ generalfit.h $(INC)exceptions.h \
+ $(INC)peidainit.h matrix.h peida.h utils.h \
+ $(INC)machine.h \
+ $(INC)perrors.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h cvector.h generaldata.h \
+ poly.h nbconst.h tabmath.h simps2d.h
+$(OBJ)generaldata.o: generaldata.cc $(INC)defs.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h nbtri.h generalfit.h \
+ matrix.h peida.h utils.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h cvector.h generaldata.h \
+ poly.h
+$(OBJ)generalfit.o: generalfit.cc $(INC)defs.h \
+ generalfit.h $(INC)exceptions.h \
+ $(INC)peidainit.h matrix.h peida.h utils.h \
+ $(INC)machine.h \
+ $(INC)perrors.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h cvector.h generaldata.h \
+ poly.h nbconst.h tabmath.h
+$(OBJ)hisprof.o: hisprof.cc $(INC)defs.h hisprof.h \
+ peida.h utils.h $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h fmath.h cvector.h matrix.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h histos.h
+$(OBJ)histos.o: histos.cc $(INC)defs.h histos.h \
+ peida.h utils.h $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h fmath.h cvector.h matrix.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h poly.h strutil.h \
+ generalfit.h generaldata.h
+$(OBJ)histos2.o: histos2.cc $(INC)defs.h histos2.h \
+ peida.h utils.h $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h fmath.h histos.h cvector.h \
+ matrix.h $(INC)ppersist.h \
+ $(INC)pclassids.h generalfit.h generaldata.h \
+ poly.h
+$(OBJ)imageop.o: imageop.cc $(INC)defs.h simplesort.h \
+ peida.h utils.h $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h fmath.h nbmath.h histos.h \
+ cvector.h matrix.h $(INC)ppersist.h \
+ $(INC)pclassids.h datatypes.h imageop.h \
+ cimage.h rzimage.h rzvect.h dvlist.h cspline.h nbtri.h
+$(OBJ)integ.o: integ.cc $(INC)defs.h integ.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h generalfit.h matrix.h \
+ peida.h utils.h $(INC)machine.h \
+ $(INC)perrors.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h cvector.h generaldata.h \
+ poly.h
+$(OBJ)linfit.o: linfit.cc $(INC)defs.h peida.h \
+ utils.h $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h fmath.h linfit.h matrix.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h cvector.h
+$(OBJ)matrix.o: matrix.cc $(INC)defs.h peida.h \
+ utils.h $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h fmath.h matrix.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h cvector.h generalfit.h \
  generaldata.h poly.h
 $(OBJ)median.o: median.cc
-$(OBJ)ntuple.o: ntuple.cc /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h /home/ansari/DPC/Include/defs.h \
- /home/ansari/DPC/Include/peidainit.h ntuple.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/machine.h \
- /home/ansari/DPC/Include/pclassids.h dvlist.h
+$(OBJ)ntuple.o: ntuple.cc $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)defs.h \
+ $(INC)peidainit.h ntuple.h \
+ $(INC)ppersist.h \
+ $(INC)machine.h \
+ $(INC)pclassids.h dvlist.h
 $(OBJ)outilsinit.o: outilsinit.cc outilsinit.h \
- /home/ansari/DPC/Include/peidainit.h /home/ansari/DPC/Include/defs.h \
- matrix.h peida.h utils.h /home/ansari/DPC/Include/machine.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h fmath.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h cvector.h poly.h dvlist.h \
+ $(INC)peidainit.h \
+ $(INC)defs.h matrix.h peida.h utils.h \
+ $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h cvector.h poly.h dvlist.h \
  histos.h histos2.h hisprof.h ntuple.h generaldata.h cimage.h \
  rzimage.h rzvect.h datatypes.h tabmath.h nbconst.h dates.h datime.h
-$(OBJ)perandom.o: perandom.cc /home/ansari/DPC/Include/defs.h perandom.h \
- /home/ansari/DPC/Include/machine.h histos.h peida.h utils.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h fmath.h cvector.h matrix.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h nbrandom.h pemath.h
-$(OBJ)poly.o: poly.cc /home/ansari/DPC/Include/defs.h poly.h peida.h utils.h \
- /home/ansari/DPC/Include/machine.h /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h fmath.h cvector.h matrix.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h linfit.h
+$(OBJ)perandom.o: perandom.cc $(INC)defs.h perandom.h \
+ $(INC)machine.h histos.h peida.h utils.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h fmath.h cvector.h matrix.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h nbrandom.h pemath.h
+$(OBJ)poly.o: poly.cc $(INC)defs.h poly.h peida.h \
+ utils.h $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h fmath.h cvector.h matrix.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h linfit.h
 $(OBJ)pversion.o: pversion.cc pversion.h \
- /home/ansari/DPC/Include/peidainit.h /home/ansari/DPC/Include/defs.h
-$(OBJ)rk4cdifeq.o: rk4cdifeq.cc /home/ansari/DPC/Include/defs.h rk4cdifeq.h \
- difeq.h /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h cvector.h matrix.h peida.h \
- utils.h /home/ansari/DPC/Include/machine.h \
- /home/ansari/DPC/Include/perrors.h fmath.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h \
- /home/ansari/DPC/Include/ctimer.h /home/ansari/DPC/Include/peida.h
-$(OBJ)rzimage.o: rzimage.cc /home/ansari/DPC/Include/defs.h rzimage.h \
- rzvect.h /home/ansari/DPC/Include/machine.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h \
- /home/ansari/DPC/Include/perrors.h datatypes.h \
- /home/ansari/DPC/Include/ppersist.h \
- /home/ansari/DPC/Include/pclassids.h dvlist.h generalfit.h matrix.h \
- peida.h utils.h fmath.h cvector.h generaldata.h poly.h
-$(OBJ)simplesort.o: simplesort.cc /home/ansari/DPC/Include/defs.h \
- simplesort.h peida.h utils.h /home/ansari/DPC/Include/machine.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h fmath.h
-$(OBJ)tabmath.o: tabmath.cc /home/ansari/DPC/Include/defs.h tabmath.h \
- peida.h utils.h /home/ansari/DPC/Include/machine.h \
- /home/ansari/DPC/Include/perrors.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h fmath.h nbconst.h
-$(OBJ)utils.o: utils.cc /home/ansari/DPC/Include/defs.h utils.h \
- /home/ansari/DPC/Include/exceptions.h \
- /home/ansari/DPC/Include/peidainit.h
-$(OBJ)datime.o: datime.c /home/ansari/DPC/Include/defs.h strutil.h nbconst.h \
- datime.h
+ $(INC)peidainit.h \
+ $(INC)defs.h
+$(OBJ)rk4cdifeq.o: rk4cdifeq.cc $(INC)defs.h \
+ rk4cdifeq.h difeq.h $(INC)exceptions.h \
+ $(INC)peidainit.h cvector.h matrix.h peida.h \
+ utils.h $(INC)machine.h \
+ $(INC)perrors.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h \
+ $(INC)ctimer.h \
+ $(INC)peida.h
+$(OBJ)rzimage.o: rzimage.cc $(INC)defs.h rzimage.h \
+ rzvect.h $(INC)machine.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h \
+ $(INC)perrors.h datatypes.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h dvlist.h generalfit.h \
+ matrix.h peida.h utils.h fmath.h cvector.h generaldata.h poly.h
+$(OBJ)simplesort.o: simplesort.cc $(INC)defs.h \
+ simplesort.h peida.h utils.h $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h fmath.h
+$(OBJ)tabmath.o: tabmath.cc $(INC)defs.h tabmath.h \
+ peida.h utils.h $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h fmath.h nbconst.h
+$(OBJ)utils.o: utils.cc $(INC)defs.h utils.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h
+$(OBJ)datime.o: datime.c $(INC)defs.h strutil.h \
+ nbconst.h datime.h
 $(OBJ)matxop.o: matxop.c matxop.h nbmath.h
 $(OBJ)nbmath.o: nbmath.c nbmath.h matxop.h nbinteg.h nbtri.h
-$(OBJ)nbrandom.o: nbrandom.c /home/ansari/DPC/Include/defs.h \
- /home/ansari/DPC/Include/machine.h nbmath.h nbrandom.h
+$(OBJ)nbrandom.o: nbrandom.c $(INC)defs.h \
+ $(INC)machine.h nbmath.h nbrandom.h
 $(OBJ)nbtri.o: nbtri.c nbtri.h
 $(OBJ)strutil.o: strutil.c strutil.h