Index: trunk/SophyaLib/NTools/NTools.o.list
===================================================================
--- trunk/SophyaLib/NTools/NTools.o.list	(revision 243)
+++ trunk/SophyaLib/NTools/NTools.o.list	(revision 244)
@@ -25,4 +25,5 @@
 nbrandom.o
 nbtri.o
+ndatablock.o
 ntuple.o
 outilsinit.o
Index: trunk/SophyaLib/NTools/cimage.cc
===================================================================
--- trunk/SophyaLib/NTools/cimage.cc	(revision 243)
+++ trunk/SophyaLib/NTools/cimage.cc	(revision 244)
@@ -5,8 +5,8 @@
 // LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
 
-// $Id: cimage.cc,v 1.1.1.1 1999-04-09 17:57:57 ansari Exp $        
-
-
-#include "defs.h"
+// $Id: cimage.cc,v 1.2 1999-04-22 16:18:19 ansari Exp $        
+
+
+#include "machdefs.h"
 #include <string.h>
 #include <stdio.h>
Index: trunk/SophyaLib/NTools/cspline.cc
===================================================================
--- trunk/SophyaLib/NTools/cspline.cc	(revision 243)
+++ trunk/SophyaLib/NTools/cspline.cc	(revision 244)
@@ -1,3 +1,3 @@
-#include "defs.h"
+#include "machdefs.h"
 
 #include <stdlib.h>
Index: trunk/SophyaLib/NTools/cspline.h
===================================================================
--- trunk/SophyaLib/NTools/cspline.h	(revision 243)
+++ trunk/SophyaLib/NTools/cspline.h	(revision 244)
@@ -2,6 +2,5 @@
 #define CSPLINE_H_SEEN
 
-#include "defs.h"
-#include "machine.h"
+#include "machdefs.h"
 #include "cvector.h"
 
Index: trunk/SophyaLib/NTools/cvector.cc
===================================================================
--- trunk/SophyaLib/NTools/cvector.cc	(revision 243)
+++ trunk/SophyaLib/NTools/cvector.cc	(revision 244)
@@ -1,3 +1,3 @@
-#include "defs.h"
+#include "machdefs.h"
 #include <string.h>
 #include "cvector.h"
Index: trunk/SophyaLib/NTools/datacards.cc
===================================================================
--- trunk/SophyaLib/NTools/datacards.cc	(revision 243)
+++ trunk/SophyaLib/NTools/datacards.cc	(revision 244)
@@ -1,3 +1,3 @@
-// $Id: datacards.cc,v 1.1.1.1 1999-04-09 17:57:55 ansari Exp $
+// $Id: datacards.cc,v 1.2 1999-04-22 16:18:22 ansari Exp $
 //
 // Datacards, acquisition EROS II
@@ -8,5 +8,5 @@
 // DAPNIA/SPP (Saclay) / CEA
 
-#include "defs.h"
+#include "machdefs.h"
 #include "datacards.h"
 #include <algorithm>
Index: trunk/SophyaLib/NTools/datatypes.cc
===================================================================
--- trunk/SophyaLib/NTools/datatypes.cc	(revision 243)
+++ trunk/SophyaLib/NTools/datatypes.cc	(revision 244)
@@ -5,5 +5,4 @@
 // LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
 
-#include "defs.h"
 #include "datatypes.h"
 
Index: trunk/SophyaLib/NTools/datatypes.h
===================================================================
--- trunk/SophyaLib/NTools/datatypes.h	(revision 243)
+++ trunk/SophyaLib/NTools/datatypes.h	(revision 244)
@@ -7,5 +7,5 @@
 #define DATATYPES_H_SEEN
 
-#include "machine.h"
+#include "machdefs.h"
 
 
Index: trunk/SophyaLib/NTools/datime.c
===================================================================
--- trunk/SophyaLib/NTools/datime.c	(revision 243)
+++ trunk/SophyaLib/NTools/datime.c	(revision 244)
@@ -1,3 +1,3 @@
-#include "defs.h"
+#include "machdefs.h"
 #include <stdlib.h>
 #include <stdio.h>
Index: trunk/SophyaLib/NTools/difeq.cc
===================================================================
--- trunk/SophyaLib/NTools/difeq.cc	(revision 243)
+++ trunk/SophyaLib/NTools/difeq.cc	(revision 244)
@@ -1,3 +1,2 @@
-#include "defs.h"
 #include "difeq.h"
 #include "ctimer.h"
Index: trunk/SophyaLib/NTools/difeq.h
===================================================================
--- trunk/SophyaLib/NTools/difeq.h	(revision 243)
+++ trunk/SophyaLib/NTools/difeq.h	(revision 244)
@@ -3,6 +3,6 @@
 #define DIFEQ_H_SEEN
 
-#include "defs.h"
-#include "exceptions.h"
+#include "machdefs.h"
+#include "pexceptions.h"
 #include "cvector.h"
 
Index: trunk/SophyaLib/NTools/dvlist.cc
===================================================================
--- trunk/SophyaLib/NTools/dvlist.cc	(revision 243)
+++ trunk/SophyaLib/NTools/dvlist.cc	(revision 244)
@@ -3,5 +3,5 @@
 // LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
 
-#include "defs.h"
+#include "machdefs.h"
 #include <stdlib.h>
 #include <stdio.h>
Index: trunk/SophyaLib/NTools/dynccd.cc
===================================================================
--- trunk/SophyaLib/NTools/dynccd.cc	(revision 243)
+++ trunk/SophyaLib/NTools/dynccd.cc	(revision 244)
@@ -1,3 +1,3 @@
-#include "defs.h"
+#include "machdefs.h"
 #include <stdlib.h>
 #include <stdio.h>
Index: trunk/SophyaLib/NTools/dynccd.h
===================================================================
--- trunk/SophyaLib/NTools/dynccd.h	(revision 243)
+++ trunk/SophyaLib/NTools/dynccd.h	(revision 244)
@@ -4,6 +4,6 @@
 #define DYNCCD_H_SEEN
 
-#include "machine.h"
-#include "exceptions.h"
+#include "machdefs.h"
+#include "pexceptions.h"
 #include "ppersist.h"
 
Index: trunk/SophyaLib/NTools/fct1dfit.cc
===================================================================
--- trunk/SophyaLib/NTools/fct1dfit.cc	(revision 243)
+++ trunk/SophyaLib/NTools/fct1dfit.cc	(revision 244)
@@ -1,3 +1,3 @@
-#include "defs.h"
+#include "machdefs.h"
 #include <stdio.h>
 #include <stdlib.h>
Index: trunk/SophyaLib/NTools/fct2dfit.cc
===================================================================
--- trunk/SophyaLib/NTools/fct2dfit.cc	(revision 243)
+++ trunk/SophyaLib/NTools/fct2dfit.cc	(revision 244)
@@ -1,3 +1,3 @@
-#include "defs.h"
+#include "machdefs.h"
 #include <stdio.h>
 #include <stdlib.h>
Index: trunk/SophyaLib/NTools/generaldata.cc
===================================================================
--- trunk/SophyaLib/NTools/generaldata.cc	(revision 243)
+++ trunk/SophyaLib/NTools/generaldata.cc	(revision 244)
@@ -1,3 +1,3 @@
-#include "defs.h"
+#include "machdefs.h"
 #include <stdio.h>
 #include <stdlib.h>
Index: trunk/SophyaLib/NTools/generaldata.h
===================================================================
--- trunk/SophyaLib/NTools/generaldata.h	(revision 243)
+++ trunk/SophyaLib/NTools/generaldata.h	(revision 244)
@@ -2,5 +2,5 @@
 #define GENERALDATA_SEEN
 
-#include "exceptions.h"
+#include "pexceptions.h"
 #include "ppersist.h"
 #include "poly.h"
Index: trunk/SophyaLib/NTools/generalfit.cc
===================================================================
--- trunk/SophyaLib/NTools/generalfit.cc	(revision 243)
+++ trunk/SophyaLib/NTools/generalfit.cc	(revision 244)
@@ -1,3 +1,3 @@
-#include "defs.h"
+#include "machdefs.h"
 #include <stdio.h>
 #include <stdlib.h>
Index: trunk/SophyaLib/NTools/generalfit.h
===================================================================
--- trunk/SophyaLib/NTools/generalfit.h	(revision 243)
+++ trunk/SophyaLib/NTools/generalfit.h	(revision 244)
@@ -3,5 +3,5 @@
 #define GENERALFIT_SEEN
 
-#include "exceptions.h"
+#include "pexceptions.h"
 #include "matrix.h"
 #include "cvector.h"
Index: trunk/SophyaLib/NTools/hisprof.cc
===================================================================
--- trunk/SophyaLib/NTools/hisprof.cc	(revision 243)
+++ trunk/SophyaLib/NTools/hisprof.cc	(revision 244)
@@ -1,3 +1,3 @@
-#include "defs.h"
+#include "machdefs.h"
 #include <string.h>
 #include <stdio.h>
Index: trunk/SophyaLib/NTools/histos.cc
===================================================================
--- trunk/SophyaLib/NTools/histos.cc	(revision 243)
+++ trunk/SophyaLib/NTools/histos.cc	(revision 244)
@@ -1,7 +1,7 @@
 //
-// $Id: histos.cc,v 1.1.1.1 1999-04-09 17:57:56 ansari Exp $
-//
-
-#include "defs.h"
+// $Id: histos.cc,v 1.2 1999-04-22 16:18:36 ansari Exp $
+//
+
+#include "machdefs.h"
 #include <string.h>
 #include <stdio.h>
Index: trunk/SophyaLib/NTools/histos2.cc
===================================================================
--- trunk/SophyaLib/NTools/histos2.cc	(revision 243)
+++ trunk/SophyaLib/NTools/histos2.cc	(revision 244)
@@ -3,5 +3,5 @@
 //
 
-#include "defs.h"
+#include "machdefs.h"
 
 #include <string.h>
Index: trunk/SophyaLib/NTools/histos2.h
===================================================================
--- trunk/SophyaLib/NTools/histos2.h	(revision 243)
+++ trunk/SophyaLib/NTools/histos2.h	(revision 244)
@@ -6,5 +6,5 @@
 #define HISTOS2_SEEN
 
-#include "defs.h"
+#include "machdefs.h"
 #include <string>
 
Index: trunk/SophyaLib/NTools/imageop.cc
===================================================================
--- trunk/SophyaLib/NTools/imageop.cc	(revision 243)
+++ trunk/SophyaLib/NTools/imageop.cc	(revision 244)
@@ -1,3 +1,3 @@
-#include "defs.h"
+#include "machdefs.h"
 #include <stdio.h>
 #include <stdlib.h>
Index: trunk/SophyaLib/NTools/integ.cc
===================================================================
--- trunk/SophyaLib/NTools/integ.cc	(revision 243)
+++ trunk/SophyaLib/NTools/integ.cc	(revision 244)
@@ -1,3 +1,2 @@
-#include "defs.h"
 #include "integ.h"
 #include "generalfit.h"
Index: trunk/SophyaLib/NTools/integ.h
===================================================================
--- trunk/SophyaLib/NTools/integ.h	(revision 243)
+++ trunk/SophyaLib/NTools/integ.h	(revision 244)
@@ -3,5 +3,5 @@
 // integ.h
 //
-// $Id: integ.h,v 1.1.1.1 1999-04-09 17:57:55 ansari Exp $
+// $Id: integ.h,v 1.2 1999-04-22 16:18:40 ansari Exp $
 //
 
@@ -9,6 +9,6 @@
 #define INTEG_H_SEEN
 
-#include "defs.h"
-#include "exceptions.h"
+#include "machdefs.h"
+#include "pexceptions.h"
 #include <set>
 #if defined(__KCC__)
Index: trunk/SophyaLib/NTools/linfit.cc
===================================================================
--- trunk/SophyaLib/NTools/linfit.cc	(revision 243)
+++ trunk/SophyaLib/NTools/linfit.cc	(revision 244)
@@ -1,3 +1,3 @@
-#include "defs.h"
+#include "machdefs.h"
 #include "peida.h"
 #include "linfit.h"
Index: trunk/SophyaLib/NTools/matrix.cc
===================================================================
--- trunk/SophyaLib/NTools/matrix.cc	(revision 243)
+++ trunk/SophyaLib/NTools/matrix.cc	(revision 244)
@@ -1,5 +1,5 @@
-// $Id: matrix.cc,v 1.1.1.1 1999-04-09 17:57:56 ansari Exp $
-
-#include "defs.h"
+// $Id: matrix.cc,v 1.2 1999-04-22 16:18:41 ansari Exp $
+
+#include "machdefs.h"
 #include <string.h>
 #include <iostream.h>
Index: trunk/SophyaLib/NTools/median.h
===================================================================
--- trunk/SophyaLib/NTools/median.h	(revision 243)
+++ trunk/SophyaLib/NTools/median.h	(revision 244)
@@ -1,5 +1,5 @@
 // This may look like C code, but it is really -*- C++ -*-
 
-#include "defs.h"
+#include "machdefs.h"
 
 // Filtre median, retourne la valeur mediane du tableau tab.
Index: trunk/SophyaLib/NTools/nbmath.h
===================================================================
--- trunk/SophyaLib/NTools/nbmath.h	(revision 243)
+++ trunk/SophyaLib/NTools/nbmath.h	(revision 244)
@@ -4,5 +4,5 @@
 #define NBMATH_H_SEEN
 
-#include <machine.h>
+#include "machdefs.h"
 
 #ifdef __cplusplus
Index: trunk/SophyaLib/NTools/nbrandom.c
===================================================================
--- trunk/SophyaLib/NTools/nbrandom.c	(revision 243)
+++ trunk/SophyaLib/NTools/nbrandom.c	(revision 244)
@@ -1,8 +1,9 @@
-#include "defs.h"
+#include "machdefs.h"
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#include <math.h>
 #include <sys/time.h>
-#include "machine.h"
+#include "machdefs.h"
 #include "nbmath.h"
 #include "nbrandom.h"
Index: trunk/SophyaLib/NTools/nbrandom.h
===================================================================
--- trunk/SophyaLib/NTools/nbrandom.h	(revision 243)
+++ trunk/SophyaLib/NTools/nbrandom.h	(revision 244)
@@ -5,5 +5,5 @@
 #define NBRANDOM_H_SEEN
 
-#include "defs.h"
+#include "machdefs.h"
 #include <stdlib.h>
 #ifdef __mac__
Index: trunk/SophyaLib/NTools/nbtri.h
===================================================================
--- trunk/SophyaLib/NTools/nbtri.h	(revision 243)
+++ trunk/SophyaLib/NTools/nbtri.h	(revision 244)
@@ -6,5 +6,5 @@
 
 
-#include <machine.h>
+#include "machdefs.h"
 
 #ifdef __cplusplus
Index: trunk/SophyaLib/NTools/outilsinit.cc
===================================================================
--- trunk/SophyaLib/NTools/outilsinit.cc	(revision 243)
+++ trunk/SophyaLib/NTools/outilsinit.cc	(revision 244)
@@ -41,13 +41,9 @@
   PPRegister(GeneralFitData);
 
-  PPersistMgr::RegisterClass(RzImage::classId,  RzImage::Create);
-  { ImageU2 iu2;
-  PPersistMgr::RegisterClass(iu2.ClassId(),  ImageU2::Create); }
-  { ImageI2 ii2;
-  PPersistMgr::RegisterClass(ii2.ClassId(),  ImageI2::Create); }
-  { ImageI4 ii4;
-  PPersistMgr::RegisterClass(ii4.ClassId(),  ImageI4::Create); }
-  { ImageR4 ir4;
-  PPersistMgr::RegisterClass(ir4.ClassId(),  ImageR4::Create); }
+  PPRegister(RzImage);
+  PPRegister(ImageU2);
+  PPRegister(ImageI2);
+  PPRegister(ImageI4);
+  PPRegister(ImageR4);
 
   //PPersistMgr::RegisterClass(Matrix::classId,  Matrix::Create);
Index: trunk/SophyaLib/NTools/peida.h
===================================================================
--- trunk/SophyaLib/NTools/peida.h	(revision 243)
+++ trunk/SophyaLib/NTools/peida.h	(revision 244)
@@ -4,9 +4,8 @@
 #define PEIDA_SEEN
 
-#include "defs.h"
+#include "machdefs.h"
 #include "utils.h"
-#include "machine.h"
 #include "perrors.h"
-#include "exceptions.h"
+#include "pexceptions.h"
 #include "fmath.h"
 
Index: trunk/SophyaLib/NTools/pemath.h
===================================================================
--- trunk/SophyaLib/NTools/pemath.h	(revision 243)
+++ trunk/SophyaLib/NTools/pemath.h	(revision 244)
@@ -5,5 +5,5 @@
 #define PEMATH_SEEN
 
-#include "machine.h"
+#include "machdefs.h"
 
 #define  Pi     (double) (3.1415926535898)    /* c'est Pi */
Index: trunk/SophyaLib/NTools/perandom.cc
===================================================================
--- trunk/SophyaLib/NTools/perandom.cc	(revision 243)
+++ trunk/SophyaLib/NTools/perandom.cc	(revision 244)
@@ -1,3 +1,4 @@
-#include "defs.h"
+#include "machdefs.h"
+#include "pexceptions.h"
 #include "perandom.h"
 #include "pemath.h"
@@ -198,5 +199,5 @@
 {
   x = ranX->BinRandom();
-  FAILNIL(ranY[x]);
+  //  FAILNIL(ranY[x]);  Ne compile pas $CHECK$ Reza 22/04/99
   y = ranY[x]->BinRandom();
 }
@@ -211,5 +212,5 @@
   x = ranX->Random();
   int i = int(ceil(x));
-  FAILNIL(ranY[i]);
+  //  FAILNIL(ranY[i]);  Ne compile pas $CHECK$ Reza 22/04/99
   y = ranY[i]->Random();
 }
Index: trunk/SophyaLib/NTools/perandom.h
===================================================================
--- trunk/SophyaLib/NTools/perandom.h	(revision 243)
+++ trunk/SophyaLib/NTools/perandom.h	(revision 244)
@@ -6,7 +6,6 @@
 #define PERANDOM_SEEN
 
+#include "machdefs.h"
 #include <stdlib.h>
-#include "defs.h"
-#include "machine.h"
 #include "histos.h"
 #include "nbrandom.h"
Index: trunk/SophyaLib/NTools/poly.cc
===================================================================
--- trunk/SophyaLib/NTools/poly.cc	(revision 243)
+++ trunk/SophyaLib/NTools/poly.cc	(revision 244)
@@ -1,3 +1,3 @@
-#include "defs.h"
+#include "machdefs.h"
 #include "poly.h"
 #include "linfit.h"
@@ -320,11 +320,13 @@
   Realloc(dg, true);
 
-  #ifdef DEBUG
+#ifdef DEBUG
   int r = nr; int c = nc;
-  #endif
+#endif
 
   Vector::ReadSelf(s);
 
+#ifdef DEBUG
   DBASSERT(r == nr && c == nc);
+#endif
   UpdateDeg();
 
@@ -796,11 +798,13 @@
   Realloc(dgx, dgy);
 
-  #ifdef DEBUG
+#ifdef DEBUG
   int r = nr; int c = nc;
-  #endif
+#endif
 
   Vector::ReadSelf(s);
 
+#ifdef DEBUG
   DBASSERT(r == nr && c == nc);
+#endif
   UpdateDeg();
 }
Index: trunk/SophyaLib/NTools/rk4cdifeq.cc
===================================================================
--- trunk/SophyaLib/NTools/rk4cdifeq.cc	(revision 243)
+++ trunk/SophyaLib/NTools/rk4cdifeq.cc	(revision 244)
@@ -1,3 +1,3 @@
-#include "defs.h"
+#include "machdefs.h"
 #include "rk4cdifeq.h"
 #include "ctimer.h"
Index: trunk/SophyaLib/NTools/rzimage.cc
===================================================================
--- trunk/SophyaLib/NTools/rzimage.cc	(revision 243)
+++ trunk/SophyaLib/NTools/rzimage.cc	(revision 244)
@@ -5,7 +5,7 @@
 // LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
 
-//  $Id: rzimage.cc,v 1.1.1.1 1999-04-09 17:57:57 ansari Exp $
-
-#include "defs.h"
+//  $Id: rzimage.cc,v 1.2 1999-04-22 16:18:49 ansari Exp $
+
+#include "machdefs.h"
 #include <stdlib.h>
 #include <stdio.h>
Index: trunk/SophyaLib/NTools/rzvect.h
===================================================================
--- trunk/SophyaLib/NTools/rzvect.h	(revision 243)
+++ trunk/SophyaLib/NTools/rzvect.h	(revision 244)
@@ -7,6 +7,6 @@
 #define RZVECT_SEEN
 
-#include "machine.h"
-#include "exceptions.h"
+#include "machdefs.h"
+#include "pexceptions.h"
 #include "perrors.h"
 
Index: trunk/SophyaLib/NTools/simplesort.cc
===================================================================
--- trunk/SophyaLib/NTools/simplesort.cc	(revision 243)
+++ trunk/SophyaLib/NTools/simplesort.cc	(revision 244)
@@ -1,7 +1,7 @@
 //
-// $Id: simplesort.cc,v 1.1.1.1 1999-04-09 17:57:58 ansari Exp $
+// $Id: simplesort.cc,v 1.2 1999-04-22 16:18:50 ansari Exp $
 //
 
-#include "defs.h"
+#include "machdefs.h"
 #include "simplesort.h"
 #include <stdlib.h>
Index: trunk/SophyaLib/NTools/tabmath.cc
===================================================================
--- trunk/SophyaLib/NTools/tabmath.cc	(revision 243)
+++ trunk/SophyaLib/NTools/tabmath.cc	(revision 244)
@@ -1,3 +1,3 @@
-#include "defs.h"
+#include "machdefs.h"
 #include "tabmath.h"
 
Index: trunk/SophyaLib/NTools/utils.cc
===================================================================
--- trunk/SophyaLib/NTools/utils.cc	(revision 243)
+++ trunk/SophyaLib/NTools/utils.cc	(revision 244)
@@ -1,14 +1,13 @@
 // This may look like C code, but it is really -*- C++ -*-
 //
-// $Id: utils.cc,v 1.1.1.1 1999-04-09 17:57:57 ansari Exp $
+// $Id: utils.cc,v 1.2 1999-04-22 16:18:51 ansari Exp $
 //
 
-#include "defs.h"
+#include "machdefs.h"
 #include "utils.h"
-#include "exceptions.h"
+#include "pexceptions.h"
 #include <string.h>
 
 // MemCpy marche meme en cas de recouvrement.
-
 void* MemCpy(void* dest, const void* source, size_t n)
 {
Index: trunk/SophyaLib/NTools/utils.h
===================================================================
--- trunk/SophyaLib/NTools/utils.h	(revision 243)
+++ trunk/SophyaLib/NTools/utils.h	(revision 244)
@@ -1,5 +1,5 @@
 // This may look like C code, but it is really -*- C++ -*-
 //
-// $Id: utils.h,v 1.1.1.1 1999-04-09 17:57:56 ansari Exp $
+// $Id: utils.h,v 1.2 1999-04-22 16:18:52 ansari Exp $
 //
 
@@ -7,5 +7,5 @@
 #define UTILS_EA
 
-#include "defs.h"
+#include "machdefs.h"
 #include <string.h>
 #include <string>