Index: trunk/SophyaLib/NTools/NTools.o.list
===================================================================
--- trunk/SophyaLib/NTools/NTools.o.list	(revision 253)
+++ trunk/SophyaLib/NTools/NTools.o.list	(revision 253)
@@ -0,0 +1,37 @@
+cimage.o
+cspline.o
+cvector.o
+datacards.o
+datatypes.o
+dates.o
+datime.o
+difeq.o
+dvlist.o
+dynccd.o
+fct1dfit.o
+fct2dfit.o
+generaldata.o
+generalfit.o
+hisprof.o
+histos.o
+histos2.o
+imageop.o
+integ.o
+linfit.o
+matrix.o
+matxop.o
+median.o
+nbmath.o
+nbrandom.o
+nbtri.o
+ntuple.o
+outilsinit.o
+perandom.o
+poly.o
+pversion.o
+rk4cdifeq.o
+rzimage.o
+simplesort.o
+strutil.o
+tabmath.o
+utils.o
Index: trunk/SophyaLib/NTools/cimage.cc
===================================================================
--- trunk/SophyaLib/NTools/cimage.cc	(revision 252)
+++ trunk/SophyaLib/NTools/cimage.cc	(revision 253)
@@ -5,5 +5,5 @@
 // LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
 
-// $Id: cimage.cc,v 1.2 1999-04-22 16:18:19 ansari Exp $        
+// $Id: cimage.cc,v 1.3 1999-04-23 09:30:16 ansari Exp $        
 
 
@@ -1380,6 +1380,6 @@
               pim_lpav_x, pim_lpav_y,
               org_copie_x,org_copie_y,cutmin,cutmax);
-  }  CATCH(merr) {
-    if (merr != rangeCheckErr) THROW(merr);  // Re- $CHECK$ CMV+Reza 30/09/96
+  }  catch(RangeCheckError) {
+      // if (merr != rangeCheckErr) THROW(merr);   Re- $CHECK$ CMV+Reza 30/09/96
   } ENDTRY
 }
Index: trunk/SophyaLib/NTools/history_eros
===================================================================
--- trunk/SophyaLib/NTools/history_eros	(revision 253)
+++ trunk/SophyaLib/NTools/history_eros	(revision 253)
@@ -0,0 +1,139 @@
+NTools from Outils++
+-----------> cspline.cc
+   Repository revision:	1.5	/projects/Eros/CVSEros/CodeCxx/Outils/cspline.cc,v
+-----------> cspline.h
+   Repository revision:	1.4	/projects/Eros/CVSEros/CodeCxx/Outils/cspline.h,v
+-----------> cvector.cc
+   Repository revision:	1.8	/projects/Eros/CVSEros/CodeCxx/Outils/cvector.cc,v
+-----------> cvector.h
+   Repository revision:	1.7	/projects/Eros/CVSEros/CodeCxx/Outils/cvector.h,v
+-----------> datacards.cc
+   Repository revision:	1.18	/projects/Eros/CVSEros/CodeCxx/Outils/datacards.cc,v
+-----------> datacards.h
+   Repository revision:	1.10	/projects/Eros/CVSEros/CodeCxx/Outils/datacards.h,v
+-----------> datatypes.cc
+   Repository revision:	1.5	/projects/Eros/CVSEros/CodeCxx/Outils/datatypes.cc,v
+-----------> datatypes.h
+   Repository revision:	1.4	/projects/Eros/CVSEros/CodeCxx/Outils/datatypes.h,v
+-----------> dates.cc
+   Repository revision:	1.11	/projects/Eros/CVSEros/CodeCxx/Outils/dates.cc,v
+-----------> dates.h
+   Repository revision:	1.9	/projects/Eros/CVSEros/CodeCxx/Outils/dates.h,v
+-----------> difeq.cc
+   Repository revision:	1.9	/projects/Eros/CVSEros/CodeCxx/Outils/difeq.cc,v
+-----------> difeq.h
+   Repository revision:	1.6	/projects/Eros/CVSEros/CodeCxx/Outils/difeq.h,v
+-----------> dvlist.cc
+   Repository revision:	1.9	/projects/Eros/CVSEros/CodeCxx/Outils/dvlist.cc,v
+-----------> dvlist.h
+   Repository revision:	1.14	/projects/Eros/CVSEros/CodeCxx/Outils/dvlist.h,v
+-----------> fct1dfit.cc
+   Repository revision:	1.7	/projects/Eros/CVSEros/CodeCxx/Outils/fct1dfit.cc,v
+-----------> fct1dfit.h
+   Repository revision:	1.4	/projects/Eros/CVSEros/CodeCxx/Outils/fct1dfit.h,v
+-----------> fct2dfit.cc
+   Repository revision:	1.8	/projects/Eros/CVSEros/CodeCxx/Outils/fct2dfit.cc,v
+-----------> fct2dfit.h
+   Repository revision:	1.4	/projects/Eros/CVSEros/CodeCxx/Outils/fct2dfit.h,v
+-----------> generaldata.cc
+   Repository revision:	1.6	/projects/Eros/CVSEros/CodeCxx/Outils/generaldata.cc,v
+-----------> generaldata.h
+   Repository revision:	1.4	/projects/Eros/CVSEros/CodeCxx/Outils/generaldata.h,v
+-----------> generalfit.cc
+   Repository revision:	1.47	/projects/Eros/CVSEros/CodeCxx/Outils/generalfit.cc,v
+-----------> generalfit.h
+   Repository revision:	1.20	/projects/Eros/CVSEros/CodeCxx/Outils/generalfit.h,v
+-----------> hisprof.cc
+   Repository revision:	1.3	/projects/Eros/CVSEros/CodeCxx/Outils/hisprof.cc,v
+-----------> hisprof.h
+   Repository revision:	1.3	/projects/Eros/CVSEros/CodeCxx/Outils/hisprof.h,v
+-----------> histos.cc
+   Repository revision:	1.27	/projects/Eros/CVSEros/CodeCxx/Outils/histos.cc,v
+-----------> histos.h
+   Repository revision:	1.19	/projects/Eros/CVSEros/CodeCxx/Outils/histos.h,v
+-----------> histos2.cc
+   Repository revision:	1.17	/projects/Eros/CVSEros/CodeCxx/Outils/histos2.cc,v
+-----------> histos2.h
+   Repository revision:	1.15	/projects/Eros/CVSEros/CodeCxx/Outils/histos2.h,v
+-----------> integ.cc
+   Repository revision:	1.8	/projects/Eros/CVSEros/CodeCxx/Outils/integ.cc,v
+-----------> integ.h
+   Repository revision:	1.6	/projects/Eros/CVSEros/CodeCxx/Outils/integ.h,v
+-----------> linfit.cc
+   Repository revision:	1.4	/projects/Eros/CVSEros/CodeCxx/Outils/linfit.cc,v
+-----------> linfit.h
+   Repository revision:	1.7	/projects/Eros/CVSEros/CodeCxx/Outils/linfit.h,v
+-----------> matrix.cc
+   Repository revision:	1.17	/projects/Eros/CVSEros/CodeCxx/Outils/matrix.cc,v
+-----------> matrix.h
+   Repository revision:	1.8	/projects/Eros/CVSEros/CodeCxx/Outils/matrix.h,v
+-----------> median.cc
+   Repository revision:	1.1	/projects/Eros/CVSEros/CodeCxx/Outils/median.cc,v
+-----------> median.h
+   Repository revision:	1.1	/projects/Eros/CVSEros/CodeCxx/Outils/median.h,v
+-----------> nbconst.h
+   Repository revision:	1.6	/projects/Eros/CVSEros/CodeCxx/Outils/nbconst.h,v
+-----------> ntuple.cc
+   Repository revision:	1.12	/projects/Eros/CVSEros/CodeCxx/Outils/ntuple.cc,v
+-----------> ntuple.h
+   Repository revision:	1.9	/projects/Eros/CVSEros/CodeCxx/Outils/ntuple.h,v
+-----------> outilsinit.cc
+   Repository revision:	1.2	/projects/Eros/CVSEros/CodeCxx/Outils/outilsinit.cc,v
+-----------> outilsinit.h
+   Repository revision:	1.3	/projects/Eros/CVSEros/CodeCxx/Outils/outilsinit.h,v
+-----------> pclassids.h
+   Repository revision:	1.8	/projects/Eros/CVSEros/CodeCxx/Outils/pclassids.h,v
+-----------> peida.h
+   Repository revision:	1.4	/projects/Eros/CVSEros/CodeCxx/Outils/peida.h,v
+-----------> pemath.h
+   Repository revision:	1.2	/projects/Eros/CVSEros/CodeCxx/Outils/pemath.h,v
+-----------> perandom.cc
+   Repository revision:	1.11	/projects/Eros/CVSEros/CodeCxx/Outils/perandom.cc,v
+-----------> perandom.h
+   Repository revision:	1.8	/projects/Eros/CVSEros/CodeCxx/Outils/perandom.h,v
+-----------> poly.cc
+   Repository revision:	1.10	/projects/Eros/CVSEros/CodeCxx/Outils/poly.cc,v
+-----------> poly.h
+   Repository revision:	1.8	/projects/Eros/CVSEros/CodeCxx/Outils/poly.h,v
+-----------> pversion.cc
+   Repository revision:	1.4	/projects/Eros/CVSEros/CodeCxx/Outils/pversion.cc,v
+-----------> pversion.h
+   Repository revision:	1.37	/projects/Eros/CVSEros/CodeCxx/Outils/pversion.h,v
+-----------> rk4cdifeq.cc
+   Repository revision:	1.4	/projects/Eros/CVSEros/CodeCxx/Outils/rk4cdifeq.cc,v
+-----------> rk4cdifeq.h
+   Repository revision:	1.2	/projects/Eros/CVSEros/CodeCxx/Outils/rk4cdifeq.h,v
+-----------> simplesort.cc
+   Repository revision:	1.9	/projects/Eros/CVSEros/CodeCxx/Outils/simplesort.cc,v
+-----------> simplesort.h
+   Repository revision:	1.11	/projects/Eros/CVSEros/CodeCxx/Outils/simplesort.h,v
+-----------> simps2d.h
+   Repository revision:	1.1	/projects/Eros/CVSEros/CodeCxx/Outils/simps2d.h,v
+-----------> tabmath.cc
+   Repository revision:	1.3	/projects/Eros/CVSEros/CodeCxx/Outils/tabmath.cc,v
+-----------> tabmath.h
+   Repository revision:	1.2	/projects/Eros/CVSEros/CodeCxx/Outils/tabmath.h,v
+-----------> utils.cc
+   Repository revision:	1.9	/projects/Eros/CVSEros/CodeCxx/Outils/utils.cc,v
+-----------> utils.h
+   Repository revision:	1.14	/projects/Eros/CVSEros/CodeCxx/Outils/utils.h,v
+
+NTools from Images++
+-----------> cimage.cc
+   Repository revision:	1.36	/projects/Eros/CVSEros/CodeCxx/Images/cimage.cc,v
+-----------> cimage.h
+   Repository revision:	1.22	/projects/Eros/CVSEros/CodeCxx/Images/cimage.h,v
+-----------> dynccd.cc
+   Repository revision:	1.20	/projects/Eros/CVSEros/CodeCxx/Images/dynccd.cc,v
+-----------> dynccd.h
+   Repository revision:	1.11	/projects/Eros/CVSEros/CodeCxx/Images/dynccd.h,v
+-----------> imageop.cc
+   Repository revision:	1.27	/projects/Eros/CVSEros/CodeCxx/Images/imageop.cc,v
+-----------> imageop.h
+   Repository revision:	1.17	/projects/Eros/CVSEros/CodeCxx/Images/imageop.h,v
+-----------> rzimage.cc
+   Repository revision:	1.29	/projects/Eros/CVSEros/CodeCxx/Images/rzimage.cc,v
+-----------> rzimage.h
+   Repository revision:	1.13	/projects/Eros/CVSEros/CodeCxx/Images/rzimage.h,v
+-----------> rzvect.h
+   Repository revision:	1.6	/projects/Eros/CVSEros/CodeCxx/Images/rzvect.h,v
Index: trunk/SophyaLib/NTools/pclassids.h
===================================================================
--- trunk/SophyaLib/NTools/pclassids.h	(revision 252)
+++ trunk/SophyaLib/NTools/pclassids.h	(revision 253)
@@ -12,4 +12,5 @@
 enum PeidaClassIds {
 
+   ClassId_Unknown    = 0x0000,
 //  Module Outils++
    ClassId_Poly1    = 0x0101,